webkit-0.12.3: Binding to the Webkit library.

Portability | portable (depends on GHC)
Stability | provisional
Maintainer | gtk2hs-users@lists.sourceforge.net
Safe Haskell | None

Graphics.UI.Gtk.WebKit.WebFrame

Contents

- Description
- Types
- Constructors
- Methods

Description

The content of a `WebView`

Note: Functon `webkit_web_frame_get_global_context` can't binding now, Because it need `JSGlobalContextRef` exist in JavaScriptCore.

Function `webkit_web_frame_print_full` can't binding now, Because library `GtkPrintOperation` haven't binding.

Synopsis

- data WebFrame
- class GObjectClass o => WebFrameClass o
- data LoadStatus
- webFrameNew :: WebViewClass webview => webview -> IO WebFrame
- webFrameGetWebView :: WebFrameClass self => self -> IO WebView
- webFrameGetName :: WebFrameClass self => self -> IO (Maybe String)
- webFrameGetNetworkResponse :: WebFrameClass self => self -> IO (Maybe NetworkResponse)
- webFrameGetTitle :: WebFrameClass self => self -> IO (Maybe String)
- webFrameGetUri :: WebFrameClass self => self -> IO (Maybe String)
- webFrameGetParent :: WebFrameClass self => self -> IO (Maybe WebFrame)
- webFrameGetLoadStatus :: WebFrameClass self => self -> IO LoadStatus
- webFrameLoadUri :: WebFrameClass self => self -> String -> IO ()
- webFrameLoadString :: WebFrameClass self => self -> String -> Maybe String -> Maybe String -> String -> IO ()
- webFrameLoadAlternateString :: WebFrameClass self => self -> String -> String -> String -> IO ()
- webFrameLoadRequest :: (WebFrameClass self, NetworkRequestClass requ) => self -> requ -> IO ()
- webFrameStopLoading :: WebFrameClass self => self -> IO ()
- webFrameReload :: WebFrameClass self => self -> IO ()
- webFrameFindFrame :: WebFrameClass self => self -> String -> IO (Maybe WebFrame)
- webFrameGetDataSource :: WebFrameClass self => self -> IO WebDataSource
- webFrameGetHorizontalScrollbarPolicy :: WebFrameClass self => self -> IO PolicyType
- webFrameGetVerticalScrollbarPolicy :: WebFrameClass self => self -> IO PolicyType
- webFrameGetProvisionalDataSource :: WebFrameClass self => self -> IO WebDataSource
- webFrameGetSecurityOrigin :: WebFrameClass self => self -> IO SecurityOrigin
- webFramePrint :: WebFrameClass self => self -> IO ()

# Description

A WebKitWebView contains a main WebKitWebFrame. A WebKitWebFrame contains the content of one URI. The URI and name of the frame can be retrieved, the load status and progress can be observed using the signals and can be controlled using the methods of the WebKitWebFrame. A WebKitWebFrame can have any number of children and one child can be found by using `webFrameFindFrame`.

# Types

data WebFrame Source

Instances

Eq WebFrame |
Ord WebFrame |
GObjectClass WebFrame |
WebFrameClass WebFrame |

class GObjectClass o => WebFrameClass o Source

Instances

WebFrameClass WebFrame |

data LoadStatus Source

Instances

Enum LoadStatus |

# Constructors

webFrameNew Source

Arguments

:: WebViewClass webview |
=> webview | `webview` - the given webview
-> IO WebFrame |

Create a new `WebFrame` instance with the given `webview`.

A `WebFrame` contains the content of one URI.

# Methods

webFrameGetWebView :: WebFrameClass self => self -> IO WebView Source

Return the `WebView` that manages the given `WebFrame`.

webFrameGetName Source

Arguments

:: WebFrameClass self |
=> self |
-> IO (Maybe String) | the name string or `Nothing` in case failed.

Return the name of the given `WebFrame`.

webFrameGetNetworkResponse :: WebFrameClass self => self -> IO (Maybe NetworkResponse)Source

Returns a WebKitNetworkResponse object representing the response that was given to the request for the given frame, or `Nothing` if the frame was not created by a load.

- Since 1.1.18

webFrameGetTitle Source

Arguments

:: WebFrameClass self |
=> self |
-> IO (Maybe String) | the title string or `Nothing` in case failed.

Return the title of the given `WebFrame`.

webFrameGetUri Source

Arguments

:: WebFrameClass self |
=> self |
-> IO (Maybe String) | the URI string or `Nothing` in case failed.

Return the URI of the given `WebFrame`.

webFrameGetParent Source

Arguments

:: WebFrameClass self |
=> self |
-> IO (Maybe WebFrame) | a `WebFrame` or `Nothing` in case failed.

Return the `WebFrame'`s parent frame if it has one, Otherwise return Nothing.

webFrameGetLoadStatus :: WebFrameClass self => self -> IO LoadStatus Source

Determines the current status of the load.

frame : a WebKitWebView

- Since 1.1.7

webFrameLoadUri Source

Arguments

:: WebFrameClass self |
=> self |
-> String | `uri` - an URI string.
-> IO () |

Request loading of the specified URI string.

webFrameLoadString Source

Arguments

:: WebFrameClass self |
=> self |
-> String | `content` - the content string to be loaded.
-> Maybe String | `mime_type` - the MIME type or `Nothing`.
-> Maybe String | `encoding` - the encoding or `Nothing`.
-> String | `base_uri` - the base URI for relative locations.
-> IO () |

Requests loading of the given `content` with the specified `mime_type`, `encoding` and `base_uri`.

If `mime_type` is `Nothing`, "text/html" is assumed.

If `encoding` is `Nothing`, "UTF-8" is assumed.

webFrameLoadAlternateString Source

Arguments

:: WebFrameClass self |
=> self |
-> String | `content` - the alternate content to display as the main page of the frame
-> String | `base_uri` - the base URI for relative locations.
-> String | `unreachable_url` - the URL for the alternate page content.
-> IO () |

Request loading of an alternate content for a URL that is unreachable.

Using this method will preserve the back-forward list. The URI passed in `base_uri` has to be an absolute URI.

webFrameLoadRequest :: (WebFrameClass self, NetworkRequestClass requ) => self -> requ -> IO ()Source

Connects to a given URI by initiating an asynchronous client request.

Creates a provisional data source that will transition to a committed data source once any data has been received. Use `webFrameStopLoading` to stop the load. This function is typically invoked on the main frame.

webFrameStopLoading :: WebFrameClass self => self -> IO ()Source

Stops and pending loads on the given data source and those of its children.

webFrameReload :: WebFrameClass self => self -> IO ()Source

Reloads the initial request.

webFrameFindFrame Source

Arguments

:: WebFrameClass self |
=> self |
-> String | `name` - the name of the frame to be found.
-> IO (Maybe WebFrame) |

Return the `WebFrame` associated with the given name or `Nothing` in case none if found

For pre-defined names, return the given webframe if name is

webFrameGetDataSource :: WebFrameClass self => self -> IO WebDataSource Source

Returns the committed data source.

webFrameGetHorizontalScrollbarPolicy :: WebFrameClass self => self -> IO PolicyType Source

Return the policy of horizontal scrollbar.

webFrameGetVerticalScrollbarPolicy :: WebFrameClass self => self -> IO PolicyType Source

Return the policy of vertical scrollbar.

webFrameGetProvisionalDataSource :: WebFrameClass self => self -> IO WebDataSource Source

You use the `webFrameLoadRequest` method to initiate a request that creates a provisional data source. The provisional data source will transition to a committed data source once any data has been received. Use `webFrameGetDataSource` to get the committed data source.

webFrameGetSecurityOrigin :: WebFrameClass self => self -> IO SecurityOrigin Source

Returns the frame's security origin.

webFramePrint :: WebFrameClass self => self -> IO ()Source

Prints the given `WebFrame`.

by presenting a print dialog to the user.